<template>
  <div div="user">
    <b-jumbotron>
      <template slot="header">Order List {{ $route.params.orderName }}</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>

      <div>
        Orlder List {{ order.name }} for criterion
        <a @click="dispatchToCriterion(order.criterion.name)">{{order.criterion.name}}</a>
      </div>
      <div class="mydiv-tablealign">
        <table class="table table-bordered">
          <thead>
            <tr>
              <th>Student</th>
              <th>Group</th>
              <th>Department</th>
            </tr>
          </thead>
          <tr v-for="student in order.students" class="static" v-bind:key="student">
            <td
              @click="dispatchToStudent(student.second.name, student.first.name + ' ' + student.first.surname)"
            >{{student.first.name + ' ' + student.first.surname}}</td>
            <td @click="dispatchToGroup(student.second.name)">{{student.second.name}}</td>
            <td>{{student.second.department}}</td>
          </tr>
        </table>
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  name: "OrderList",
  data() {
    return {
      order: { name: "??", criterion: { name: "??" }, students: [] },
      alertMessage: "Request error",
      hasError: false
    };
  },
  mounted() {
    this.loadItems(this.$route.params.orderName);
  },
  beforeRouteUpdate(to, _, next) {
    this.loadItems(to.params.orderName);
    next();
  },
  methods: {
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    dispatchToCriterion(name) {
      this.$router.push({ name: "Criterion", params: { criterionName: name } });
    },
    dispatchToGroup(name) {
      this.$router.push({ name: "Group", params: { groupName: name } });
    },
    dispatchToStudent(group, student) {
      this.$router.push({
        name: "Student",
        params: { groupName: group, studentName: student }
      });
    },
    async loadItems(orderName) {
      let res = await AXIOS.get("/edu/order/" + orderName, {})
        .then(
          response => {
            console.log(response);
            this.order = response.data;
            return this.order;
          },
          error => {
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.order = {
              name: "??",
              criterion: { name: "??" },
              students: []
            };
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.order = { name: "??", criterion: { name: "??" }, students: [] };
          this.hasError = true;
        });
      console.log(res);
    }
  }
};
</script>

<style>
.mydiv-tablealign {
  text-align: center;
}
</style>